/* Feb 8/91- Taken from Bjarne Stroustrup book C ++ 						*/
/* Capilano Computing Systems Limited.										*/


/* This is one of the classes used to create and handle double 				*/
/* linked lists. This class will allow an object to be on multiple 			*/
/* lists at the same time. The list is made up of TDLink's which in turn 	*/
/* point to the users object. See dlist.h for details on list operations 	*/


#ifndef DLINK_H
#define DLINK_H

#include "ListObj.h"
#include "Object.h"

class TDLink : public TObject
{
	friend class TDList;
	TDLink *fNext;
	TDLink *fPrev;
	TListObject* e;

	TDLink(TListObject* a, TDLink *n =0, TDLink *p =0)
	{e = a; fNext = n; fPrev =p;}
	
	/* Insert *p after this object */
	void Insert(TDLink *p);
	
	/* Insert *p before this object */
	
	void Append(TDLink *p);
	
	/* remove this object from the list */
	
	void Remove();
	
	
	/* remove and delete this object */
	/* mostly called when user does a delete */
	
	~TDLink() { Remove(); }
};

#endif